Lua_RankTopBaseItem = class("Lua_RankTopBaseItem", Lua_DisplayObject)

function Lua_RankTopBaseItem:buildShowItem()
	self:superCall("buildShowItem")
	self.titleIcon:setEnable(false)
	
	self.avatarItem = Lua_AvatarItem.new(self.content)
end

function Lua_RankTopBaseItem:dispose()
	if self.avatarItem then
		self.avatarItem:dispose()
		self.avatarItem = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_RankTopBaseItem:setRank(value)
	self.bg:setAltas("rank_altas", "xui_phb_bg_"..(value + 1))
	self.rankText.text = LanUtil.formateStr(202538, convert_arab_to_chinese(value))
	if value == 1 then
		self.titleIcon:setLocation(0, 190, 0)
		self.rankText:setLocation(0, 26, 0)
		self.rankText.fontSize = 30
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FCF6AF")

		self.nameText:setLocation(0, -26, 0)
		self.nameText.fontSize = 30
		self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")

		self.valueText:setLocation(0, -68, 0)
		self.valueText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")

		self.avatarItem:setLocation(0, 108, 0)
		self.avatarItem:setScale(1, 1, 1)
	else
		self.titleIcon:setLocation(0, 174, 0)
		self.rankText:setLocation(0, 28, 0)
		self.rankText.fontSize = 26
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF")

		self.nameText:setLocation(0, -13, 0)
		self.nameText.fontSize = 26
		
		self.valueText:setLocation(0, -51, 0)
		self.valueText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		if value == 2 then
			self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
			self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
			self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end

		self.avatarItem:setLocation(0, 96, 0)
		self.avatarItem:setScale(0.8, 0.8, 1);
	end
end




















Lua_RankTopItem = class("Lua_RankTopItem", Lua_RankTopBaseItem)
function Lua_RankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_RankTopItem:setData(rankType, rankNum, data)
	self:setRank(rankNum)
	if data == nil then
		-- self.titleIcon:setEnable(false)
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:setEnable(false)
	else
		-- self.titleIcon:setEnable(true)
		-- local titleId = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, data.player_show.dress_info)
		-- local vo = DataCenter.roleUtil:getDressUpVoById(titleId)
		-- if vo == nil then
		-- 	self.titleIcon:setEnable(false)
		-- else
		-- 	self.titleIcon:setEnable(true)
		-- 	self.titleIcon:setAltas(vo.atlas, vo.sprite)
		-- 	self.titleIcon:resetSize()
		-- end

		self.nameText.text = data.player_show.name

		self.valueText:setEnable(true)
		if rankType >= 4 and rankType <= Lua_RankData.LIGHT_TOWER_TYPE then
			self.valueText.text = LanUtil.formateStr(202531, data.value)
		elseif rankType == Lua_RankData.FIGHT_TYPE then
			self.valueText.colorStr = Lua_ColorDefine.transColor("F7EE80")
			self.valueText.effectColorStr = Lua_ColorDefine.transColor("541814")
			self.valueText.text = spliceIconStr("number", "xui_zl1_number_10", 26, 28).." "..data.value
		elseif rankType == Lua_RankData.MAIN_LINE_TYPE then
			local config1 = Lua_MainLineCheckpointConfigData.getConfig(data.value)
			if config1 then
				local config2 = Lua_MainLineChapterConfigData.getConfig(config1.chapter_id)
				self.valueText.text = config2.name..config1.name
			else
				self.valueText:setEnable(false)
			end
		elseif rankType == Lua_RankData.KUNXUHOLYLAND_TYPE then
			self.valueText.text = LanUtil.formateStr(202536, data.value, data.sub_value, spliceIconStr("common_altas_1", "xui_common_label_06", 26, 25))
		else
			self.valueText.text = data.value
		end

		self.avatarItem:setEnable(true)
		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info)
		self.avatarItem:setAvatarBg(nil, nil)
		self.avatarItem:setRoleLevel(data.player_show.level, -50, -50)
	end
end




















Lua_ChaosForestRankTopItem = class("Lua_ChaosForestRankTopItem", Lua_RankTopBaseItem)
function Lua_ChaosForestRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_ChaosForestRankTopItem:buildShowItem()
	self:superCall("buildShowItem")
	self.checkHurt = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_yasl_button_6", 0, 0, 0, 0)
	self.checkHurt:addClickFuntion(self, self.onCheckHurt)
end

function Lua_ChaosForestRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.checkHurt:setLocation(0, -105, 0)
	else
		self.checkHurt:setLocation(0, -85, 0)
	end
end

function Lua_ChaosForestRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		-- self.titleIcon:setEnable(false)
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:setEnable(false)
		self.checkHurt:setEnable(false)
	else
		-- self.titleIcon:setEnable(true)
		-- local titleId = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, data.player_show.dress_info)
		-- local vo = DataCenter.roleUtil:getDressUpVoById(titleId)
		-- if vo == nil then
		-- 	self.titleIcon:setEnable(false)
		-- else
		-- 	self.titleIcon:setEnable(true)
		-- 	self.titleIcon:setAltas(vo.atlas, vo.sprite)
		-- 	self.titleIcon:resetSize()
		-- end

		self.nameText.text = data.player_show.name

		self.valueText:setEnable(true)
		self.valueText.text = data.value

		self.avatarItem:setEnable(true)
		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info)
		self.avatarItem:setAvatarBg(nil, nil)
		self.avatarItem:setRoleLevel(data.player_show.level, -50, -50)

		self.checkHurt:setEnable(true)
	end
end

function Lua_ChaosForestRankTopItem:onCheckHurt(go)
	if self.data == nil then
		return
	end
	Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sFightHurtCollect(self.data.player_show.id);
end




















Lua_LeagueRankTopItem = class("Lua_LeagueRankTopItem", Lua_RankTopBaseItem)
function Lua_LeagueRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_LeagueRankTopItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_LeagueRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:setEnable(false)
	else
		self.nameText.text = data.league_name

		self.valueText:setEnable(true)
		self.valueText.text = spliceIconStr("number", "xui_zl1_number_10", 26, 28).." "..data.league_force

		self.avatarItem:setEnable(true)
		self.avatarItem:setScale(1, 1, 1)
		self.avatarItem:setLeagueId(data.league_id)
		if rankNum == 1 then
			self.avatarItem:setLeagueAvatarId(data.league_head, 2, 0.5)
		else
			self.avatarItem:setLeagueAvatarId(data.league_head, 2, 0.4)
		end
	end
end




















Lua_StarTrialRankTopItem = class("Lua_StarTrialRankTopItem", Lua_RankTopBaseItem)
function Lua_StarTrialRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_StarTrialRankTopItem:buildShowItem()
	self:superCall("buildShowItem")

	self.starText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22)
	self.starText.pivotValue = 4
	self.starText.alignmentValue = 4
	self.starText.horizontalOverflowValue = 1
	self.starText.verticalOverflowValue = 1
	self.starText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
	self.starText:setEffectDistance(2, 2)
end

function Lua_StarTrialRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.nameText:setLocation(0, -18, 0)
		self.valueText:setLocation(0, -86, 0)
		self.starText:setLocation(0, -52, 0)
		self.starText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
	else
		self.nameText:setLocation(0, -7, 0)
		self.valueText:setLocation(0, -68, 0)
		self.starText:setLocation(0, -39, 0)
		self.starText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		if value == 2 then
			self.starText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.starText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end
	end
end

function Lua_StarTrialRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		-- self.titleIcon:setEnable(false)
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:setEnable(false)
		self.starText:setEnable(false)
	else
		-- self.titleIcon:setEnable(true)
		-- local titleId = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, data.player_show.dress_info)
		-- local vo = DataCenter.roleUtil:getDressUpVoById(titleId)
		-- if vo == nil then
		-- 	self.titleIcon:setEnable(false)
		-- else
		-- 	self.titleIcon:setEnable(true)
		-- 	self.titleIcon:setAltas(vo.atlas, vo.sprite)
		-- 	self.titleIcon:resetSize()
		-- end

		self.nameText.text = data.player_show.name

		self.valueText:setEnable(true)
		if data.sub_value > 0 then
			local vo = DataCenter.starTrialUitl:getStageVo(data.sub_value)
			self.valueText.text = LanUtil.formateStr(201615, vo.chapter, vo.index)
		else
			self.valueText.text = nil
		end

		self.starText:setEnable(true)
		self.starText.text = spliceIconStr("common_altas_1", "xui_common_label_06", 26, 25)..data.value

		self.avatarItem:setEnable(true)
		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info)
		self.avatarItem:setAvatarBg(nil, nil)
		self.avatarItem:setRoleLevel(data.player_show.level, -50, -50)
	end
end